unit CMH_W2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CMHist, StdCtrls, Mask, ExtCtrls;

type
  TFormMain = class(TForm)
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    EditName: TEdit;
    MaskEditTime: TMaskEdit;
    ButtonLoad: TButton;
    ButtonSave: TButton;
    ButtonExit: TButton;
    Label3: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure ButtonLoadClick(Sender: TObject);
    procedure ButtonSaveClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private-Deklarationen }
    procedure Add (Sender: TObject; var s: string; var CanAdd: Boolean);
  public
    { Public-Deklarationen }
    CMHistoryName, CMHistoryTime: TCMHistory;
  end;

var
  FormMain: TFormMain;

implementation

{$R *.DFM}

{**********************************************************************
 **********************************************************************}

procedure TFormMain.FormCreate(Sender: TObject);
begin

  { dynamic creation of two TCMHistory components }
  CMHistoryName := TCMHistory.Create (Self);
  with CMHistoryName do begin
    Parent := GroupBox1;
    Top := 20;
    Left := 55;
    EditName.Parent := CMHistoryName;
    Edit := EditName;
    IniSection := 'CMHistoryName';
    ShowHint := true;
    Hint := 'select name from history list';
  end;

  CMHistoryTime := TCMHistory.Create (Self);
  with CMHistoryTime do begin
    Parent := GroupBox2;
    Top := 20;
    Left := 55;
    MaskEditTime.Parent := CMHistoryTime;
    Edit := MaskEditTime;
    IniSection := 'CMHistoryTime';
    OnAdd := Add;
    ShowHint := true;
    Hint := 'select time from history list';
  end;

  { here you could load all histories... }
//  CMHistoriesLoad (Self, '');

end;

{**********************************************************************
 **********************************************************************}

procedure TFormMain.FormDestroy(Sender: TObject);
begin
  { here you can save all histories... }
//  CMHistoriesSave (Self, '');
end;

{**********************************************************************
 load histories of all TCMHistory components on form from default
 application ini file (= CMH_DEMO.INI)
 **********************************************************************}

procedure TFormMain.ButtonLoadClick(Sender: TObject);
begin
  CMHistoriesLoad (Self, '');
end;

{**********************************************************************
 save histories of all TCMHistory components on form to default
 application ini file (= CMH_DEMO.INI)
 **********************************************************************}

procedure TFormMain.ButtonSaveClick(Sender: TObject);
begin
  CMHistoriesSave (Self, '');
end;

{**********************************************************************
 prevent from adding input mask of TMaskEdit to history
 **********************************************************************}

procedure TFormMain.Add(Sender: TObject; var s: string; var CanAdd: Boolean);
begin
  if s = '__:__' then
    CanAdd := false;
end;

end.
